/*********************************************************************************************\
 * Envoi  NRF 24L01*
\*********************************************************************************************/
// Fonction d'envoi les données transmises par la centrale domotique
// Envoie jusqu'à 3fois si pas de réponse du clavier déporté
void BoucleEnvoi()
{
    byte i =0;
    byte Nbre = 0;

    FinAttente = 0;

        while (Nbre < 3) {
            // Envoi du message toutes les 15 secondes
            if ( millis() > FinAttente ) {
                NrfEnvoi();
                Nbre++;
            }
            // Si on recoit un message
            if( Mirf.dataReady() && !Mirf.isSending() ){
                Mirf.getData(zone_recep);                                           // on recupere le message
                strData = String((char*)zone_recep);
                    if (strData.substring(0, 13) == "60;NRFcl;RECU") {
                        Echec = false ;
                    }
            }             // sortie de if DataReady
            if (!Echec) {
                break;
            }
        }
}

// Fonction d'envoi des données au clavier déporté
void NrfEnvoi(void)
{
        #ifdef DEBUG
            Serial.print("On renvoie : ");
            Serial.println(strData);
            Serial.println(" apres 2 secondes.");
        #endif
    delay(2000);
    Mirf.send(zone_renvoi);                                             // On envoie notre reponse
    // On boucle tant que le message n'a pas ete envoye
        while(Mirf.isSending()){
            delay(10);
        }
        #ifdef DEBUG
            Serial.println("Renvoi OK.");
            Serial.println("-----------------------------------");
            Serial.println();
        #endif

    FinAttente = millis() + DUREE_ATTENTE;
    Echec = true ;                                   // Echec = True tant que l'on a pas reçu le message de retour
}
/*********************************************************************************************/

